/******************************************************************************
	Xs[JfBoC_ CPLD\[Xt@C				'08 Masaji Kasahara
	
	WX^AhX蓖	0:	hpfoutʃoCg
								1:	hpfoutʃoCg
								2:	lpfoutʃoCg
								3:	lpfoutʃoCg
								4:	䃌WX^ʃoCg
								5:	䃌WX^ʃoCg
								6:	LCDf[^
								7:	audioinʃoCg
								8:	audioinʃoCg
	
	gps̓vAbv(AssignmentssettingDeviceDevice&Pin option
	Unused PinReserve all unused pinsAs input tri-stated with weak pull-up)
******************************************************************************/

module SpDivider(clk, nrst, bus_rd, bus_stb, dat_bus, dir, 
			relay, sw, lcd_d, lcd_rs, lcd_stb, 
			cclk, clatch, cdata, sdin, lrck, bclk, rerr, ser_hpf, ser_lpf );
	input clk, nrst, bus_rd, bus_stb;	// 20MHzNbNA_Zbg
	inout[7:0] dat_bus;					// CPUf[^oX8bit
	output dir, relay;					// Oobt@Ao̓[on/off
	input[4:0] sw;						// XCb`
	output[7:4] lcd_d;					// LCDf[^
	output lcd_rs, lcd_stb;				// LCD RS,STBo
	input sdin, lrck, bclk, rerr;		// fW^I[fBIC^tF[X
	output cclk, clatch, cdata, ser_hpf, ser_lpf; // D/ARo[^֏o
	
	parameter regno = 9, wrregno = 7;	// WX^A݃WX^
	reg[7:0] rgst[wrregno-1:0];			// CPU猩郌WX^
	reg[3:0] adr;
	reg [1:0] rd2;
	reg load;
	wire [15:0] para_out;
	wire done;
	wire rst = ~nrst;

	always @(posedge bus_stb or posedge rst)begin	// CPŨWX^
		if(rst)
			adr <= 0;
		else begin
			if( !bus_rd )
				rgst[adr] <= dat_bus;
			if( adr == regno-1 )
				adr <= 0;
			else if( !(bus_rd && adr == 0) )
				adr <= adr + 1;
		end
	end
	
	always @(posedge clk)begin			// bus_rdclkɓ
		rd2   <= rd2 << 1 | bus_rd;
		load  <= rd2==2'b01;
	end
	assign dir = rd2[0] | rd2[1];		// Oobt@3state
	wire rd_int = rd2[0] & rd2[1];		// CPLDo̓sp(ԍtĂ)
	
	assign dat_bus = !rd_int? 8'hZZ:	// CPŨWX^ǂ݂
					(adr==7)? para_out[15:8]:
					(adr==8)? para_out[7:0]:
							  {1'h00, rerr, sw, (done & clatch)}; // Xe[^X

	LeftJustifyOutSlave hpf( bclk, lrck, load, {rgst[0],rgst[1]}, ser_hpf );
	LeftJustifyOutSlave lpf( bclk, lrck, load, {rgst[2],rgst[3]}, ser_lpf );
	LeftJustifyIn   AudioIn( bclk, lrck, rst, done, sdin, para_out );
	spout DACcontrol( clk, rst, load, load, {rgst[4],rgst[5]}, 
														cdata, cclk, clatch );
	LcdOut lcd( clk, load, rgst[6], lcd_d, lcd_rs, lcd_stb );

	reg[23:0] relay_cnt;				// o̓[0.8b҂
	always @(posedge clk or posedge rst)begin
		if(rst)
			relay_cnt <= -1;
		else begin
			if(rerr)
				relay_cnt <= -1;
			else if(relay_cnt != 0)
				relay_cnt <= relay_cnt - 1;
		end
	end
	assign relay = (relay_cnt == 0);
endmodule

/******************************************************************************
	LCD֏óBdsPIC̃sȂ̂CPLDoRŏo͂B
	Xg[us̃^C~OB
******************************************************************************/
module LcdOut( clk, load, indat, lcd_d, lcd_rs, lcd_stb );
	input clk, load;
	input[7:0] indat;
	output[7:4] lcd_d;
	output lcd_rs, lcd_stb;
	reg [3:0]cnt;
	reg lcd_stb;
	assign lcd_d = indat[7:4];
	assign lcd_rs= indat[0];
	
	always @(posedge clk)begin
		if( load && indat[1] )	// bit10CPLD̓f[^ȂƔf
			cnt <= 0;
		else if( ~cnt )
			cnt <= cnt + 1;
		
		if( cnt == 4 )
			lcd_stb <= 1;
		else if( cnt == 15 )
			lcd_stb <= 0;
	end
endmodule

/******************************************************************************
	pEVAϊBD/ARo[^̃[hRg[MC MD MLB
******************************************************************************/
module spout ( clk, rst, load, send, para_in, ser_out, sck, rck );
	parameter  [31:0]  width =16;
	input clk, rst, load, send;
	input [width - 1:0] para_in ;
	output ser_out, sck, rck;

	reg [6:0] bitcnt;
	reg sck, rck;
	reg [width - 1:0] sftreg;
	wire ser_out;

	always @ (posedge clk ) begin
		if (load)begin							// VtgWX^[h
			sftreg <= para_in;
		end
		else if( bitcnt!=0 && bitcnt[1:0]==0 )	// Vtg
			sftreg <= {sftreg[width-2:0],1'bX};
	end
	assign ser_out = sftreg[width - 1];

	always @ (posedge clk or posedge rst ) begin
		if (rst) begin
			bitcnt <= 0;
			rck <= 1;
			sck <= 0;
		end
		else begin
			if( bitcnt == width*4)begin			// bitcntJEgI
				bitcnt <= 0;
				rck <= 1;
				sck <= 0;
			end
			else if ( send || bitcnt!=0 )begin	// bitcntJEgJn/JEg
				bitcnt <= bitcnt + 1;
				rck <= 0;
				sck <= bitcnt[1];				// scko
			end
		end
	end
endmodule

/******************************************************************************
	fW^I[fBIC^tF[Xo͂LEFT JUSTIFYtH[}bg
	Mser_inpf[^para_outɕϊB
******************************************************************************/
module LeftJustifyIn( bclk, lrck, rst, done, ser_in, para_out );
	input bclk, lrck, rst, ser_in;
	output done;
	output [15:0] para_out;
	reg [3:0] bitcnt;
	reg [15:0] sftreg;
	reg lrck_pol, done;

	always @ (posedge bclk or posedge rst) begin
		if( rst )begin
			lrck_pol <= lrck;
			bitcnt <= 0;
		end
		else if( bitcnt == 15 )begin
			lrck_pol <= lrck;
			bitcnt <= 0;
		end
		else if( lrck_pol != lrck )
			bitcnt <= bitcnt + 1;
	end

	always @ (posedge bclk) begin
		if( lrck_pol != lrck )
			sftreg <= {sftreg[14:0],ser_in};
		done <= (bitcnt == 15);		// ϊdoneɃpXoB
	end
	assign para_out = sftreg;
endmodule

/******************************************************************************
	pf[^para_inLEFT JUSTIFYtH[}bgɕϊser_outɏo͂B
	load1ɂȂpara_in荞ށBbclk, lrckɓďo͂B
******************************************************************************/
module LeftJustifyOutSlave( bclk, lrck, load, para_in, ser_out );
	input bclk, lrck, load;
	input [15:0] para_in;
	output ser_out;
	reg before_lrck, lrck_pol;
	reg [15:0] sftreg;
	wire ser_out;

	always @ (posedge bclk) begin
		before_lrck <= lrck;
	end
	always @ (posedge load) begin
		lrck_pol <= lrck;
	end
	always @ (negedge bclk or posedge load) begin
		if (load)begin							// VtgWX^[h
			sftreg <= para_in;
		end
		else if( lrck_pol != before_lrck )		// Vtg
			sftreg <= {sftreg[14:0],1'b0};
	end
	assign ser_out = sftreg[15];
endmodule
