/******************************************************************************
	LCDj[\
******************************************************************************/

#include <p30f2012.h>
#include <string.h>
#include <stdlib.h>
#include "spdiv.h"

static int getkey()
{
	static int keyon;
	int keydat = (~PORTB) & 0x3E;	// ĂȂ0
	delay(5000);					// `^O(5msfBC)

	if( keyon ){
		if( keydat == 0 )			// L[wꂽ
			keyon = FALSE;
		return(0);
	}
	if( keydat )
		keyon = TRUE;
	return( keydat );
}

static int menu_dispi( struct menu_dat *menu )	// \
{
	MENU_VAL value = labs(*menu->value);
	int zerosuppress = FALSE;
	int curcolumn, curpos = menu->curpos;
	int n = strlen( menu->str );
	char buf[15], *cp = buf + n;
	strcpy( buf, menu->str );

	for(; n; n--){
		cp--;
		if( *cp==',' || *cp=='.' )
			continue;
		if( *cp=='+' ){
			if( *menu->value < 0 )
				*cp = '-';
			else if( *menu->value == 0 )
				*cp = ' ';
			continue;
		}

		*cp = (value % 10) + '0';
		if( zerosuppress && (value==0) )
			*cp = ' ';

		value = value / 10;
		
		if( cp[1] == '.' )
			zerosuppress = TRUE;
		if( curpos-- == 0 )
			curcolumn = menu->column + n - 1;
	}
	LCD_CUROFF;
	LCD_LOCATE( menu->row, menu->column );
	lcd_str( buf );
	LCD_LOCATE( menu->row, curcolumn );
	LCD_CURON;
	if( curpos >= 0 )							// J[\ɂ͂ݏo
		return( LEFT_KEY );
	return(0);
}

static int menu_i( struct menu_dat *menu )	// 
{
	MENU_VAL delta = 1, value = *menu->value;
	int key = getkey(), i;
	menu_dispi( menu );
	for( i=menu->curpos; i; i-- )
		delta *= 10;

	if( key == UP_KEY ){
		value += delta;
		if( value > menu->max )
			value = menu->max;
		DIS_INTERRUPT;			// 荞݋֎~
		*menu->value = value;
		ENA_INTERRUPT;			// 荞݋
		menu_dispi( menu );
	}
	else if( key == DOWN_KEY ){
		value -= delta;
		if( value < menu->min )
			value = menu->min;
		DIS_INTERRUPT;			// 荞݋֎~
		*menu->value = value;
		ENA_INTERRUPT;			// 荞݋
		menu_dispi( menu );
	}
	else if( key == LEFT_KEY ){
		menu->curpos++;
		if( menu_dispi( menu ) ){
			menu->curpos--;
			return( LEFT_KEY );
		}
		key = 0;
	}
	else if( key == RIGHT_KEY ){
		if( menu->curpos ){
			menu->curpos--;
			menu_dispi( menu );
		}
		else
			return( RIGHT_KEY );
		key = 0;
	}
	return( key );
}

static int menu_select( struct menu_dat *menu )	// Ij[
{
	int key = getkey();
	int i;
	char *cp = menu->str;
	if( key & (UP_KEY | DOWN_KEY) )
		++ *menu->value;

	for( i = *menu->value; i; i-- ){
		cp = strchr( cp, ',' );
		if( cp == NULL ){
			*menu->value = 0;
			cp = menu->str;
			break;
		}
		cp++;
	}
	LCD_CUROFF;
	LCD_LOCATE( menu->row, menu->column );
	while( *cp && *cp!=',' )
		lcd_data( *cp++ );
	LCD_LOCATE( menu->row, menu->column );
	LCD_CURON;
	return( key );
}

void menu(struct menu_dat *menu_dats, int menu_no )
{
	int key;
	static int n=0;
	if( menu_dats[n].type == INT_MENU )
		key = menu_i( menu_dats + n );
	else
		key = menu_select( menu_dats + n );

	if( key == LEFT_KEY ){
		if( n-- ==0 )
			n = menu_no-1;
	}
	else if( key & ( RIGHT_KEY | SEL_KEY ) ){
		if( n++ >= menu_no-1 )
			n=0;
	}
}
